C:::::      ,,,,,VEID02...
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**      1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      SUBROUTINE VEID02 (UNIOUT,NODNUM,NOD,DIM,NN,NDEG,SBT,
     &                   LBFI,IBUF,LBFR,RBUF,NDEGL,NDEG0L,
     &                   IOTID,MYPROC,NPROC,TIDS,NMSG,NCARD)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    VEID02     write nodes to universal file                     ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**        Copyrights University of Karlsruhe, 1995                 ***
C**        Program by L. Grosz                                      ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
       IMPLICIT NONE
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      Formal Parameters :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      INTEGER           UNIOUT,NN,DIM,NDEG,NDEGL,NDEG0L,SBT,
     &                  IOTID,MYPROC,NPROC,NMSG,LBFI,LBFR,NCARD
      INTEGER           NODNUM(NDEG),IBUF(LBFI,SBT),TIDS(NPROC)
      DOUBLE PRECISION  NOD(NN,DIM),RBUF(LBFR,SBT)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   List of Formal Parameters :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C Name   I Type I i/o I Meaning
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C UNIOUT I  I   I in  I unit of universal file
C--------I------I-----I------------------------------------------------
C NODNUM I  I   I in  I node id numbers           array: NODNUM(NDEG)
C--------I------I-----I------------------------------------------------
C DIM    I  I   I in  I space dimension
C--------I------I-----I------------------------------------------------
C NOD    I  R   I in  I node coordinates          array: NOD(NN,DIM)
C--------I------I-----I------------------------------------------------
C NDEG   I  I   I in  I number of geometrical nodes
C--------I------I-----I------------------------------------------------
C SBT    I  I   I in  I =1 no switching buffer technique
C        I      I     I =2 use switching buffer technique
C--------I------I-----I------------------------------------------------
C NDEGL  I  I   I in  I number of geometrical nodes in the
C        I      I     I node buffer on the process
C--------I------I-----I------------------------------------------------
C NDEG0L I  I   I in  I first geometrical node-1 in the
C        I      I     I node buffer on the process
C--------I------I-----I------------------------------------------------
C IBUF   I  I   I -   I integer buffer            array: IBUF(LBFI,SBT)
C--------I------I-----I------------------------------------------------
C RBUF   I  R   I -   I real buffer               array: RBUF(LBFR,SBT)
C--------I------I-----I------------------------------------------------
C IOTID  I  I   I in  I i/o task id
C--------I------I-----I------------------------------------------------
C MYPROC I  I   I in  I process id
C--------I------I-----I------------------------------------------------
C NPROC  I  I   I in  I number of processes
C--------I------I-----I------------------------------------------------
C TIDS   I  I   I in  I task ids                    array : TIDS(NPROC)
C--------I------I-----I------------------------------------------------
C NMSG   I  I   I i/o I message counter
C--------I------I-----I------------------------------------------------
C NCARD  I  I   I i/o I card counter
C--------I------I-----I------------------------------------------------
C**                    >                                            ***
      INTEGER           J,TOTID,FRTID,LL9MAP,P,MIDS1,MIDR1,NH,INFO,
     &                  Z,MYTID,TOKEN(1),SWPBUF,RCVBUF,SNDBUF,MIDR2,
     &                  MIDS2
      include"bytes.h"
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** Start of Calculation :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** scatter nodes to buffer :                                     ***
C**   -----------------------                                       ***
C**                                                                 ***
      MYTID=TIDS(MYPROC)
      TOTID=TIDS(LL9MAP(MYPROC+1,NPROC))
      FRTID=TIDS(LL9MAP(MYPROC-1,NPROC))
      RCVBUF=1
      SNDBUF=RCVBUF+(SBT-1)
	
      IBUF(1,SNDBUF)=NDEGL
      IBUF(2,SNDBUF)=NDEG0L
      DO 100 P=1,NPROC
	IF (P.EQ.1) THEN
	  IF (NPROC.GT.1) THEN
	    CALL MPRCVA(FRTID,NMSG+P,IINT*2,IBUF(1,RCVBUF),MIDR1,INFO)
	    CALL MPSNDA(TOTID,NMSG+P,IINT*2,IBUF(1,SNDBUF),MIDS1,INFO)
          ENDIF
	  DO 101 Z=3,LBFI
101         IBUF(Z,RCVBUF)=0
	  DO 102 Z=1,LBFR
102           RBUF(Z,RCVBUF)=0
	  IF (NPROC.GT.1) THEN
	    CALL MPRCVW(FRTID,NMSG+P,IINT*2,IBUF(1,RCVBUF),MIDR1,INFO)
          ENDIF
	ELSE
	  CALL MPRCVA(FRTID,NMSG+P,IINT*LBFI,IBUF(1,RCVBUF),MIDR1,INFO)
	  CALL MPRCVA(FRTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,RCVBUF),
     &                                                      MIDR2,INFO)
	  CALL MPSNDA(TOTID,NMSG+P,IINT*LBFI,IBUF(1,SNDBUF),MIDS1,INFO)
	  CALL MPSNDA(TOTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,SNDBUF),
     &                                                      MIDS2,INFO)
	  CALL MPRCVW(FRTID,NMSG+P,IINT*LBFI,IBUF(1,RCVBUF),MIDR1,INFO)
	  CALL MPRCVW(FRTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,RCVBUF),
     &                                                      MIDR2,INFO)
        ENDIF

        NDEGL=IBUF(1,RCVBUF)
        NDEG0L=IBUF(2,RCVBUF)
	DO 130 Z=1,NDEG
	  NH=NODNUM(Z)-NDEG0L
	  IF ((NH.GT.0).AND.(NH.LE.NDEGL)) IBUF(2+NH,RCVBUF)=1
130     CONTINUE
	DO 131 J=1,DIM
	  DO 131 Z=1,NDEG
	    NH=NODNUM(Z)-NDEG0L
	    IF ((NH.GT.0).AND.(NH.LE.NDEGL)) 
     &                              RBUF(DIM*(NH-1)+J,RCVBUF)=NOD(Z,J)
131     CONTINUE

	IF (P.EQ.1) THEN
	  IF (NPROC.GT.1) 
     &       CALL MPSNDW(TOTID,NMSG+P,IINT*2,IBUF(1,SNDBUF),MIDS1,INFO)
	ELSE
	  CALL MPSNDW(TOTID,NMSG+P,IINT*LBFI,IBUF(1,SNDBUF),MIDS1,INFO)
	  CALL MPSNDW(TOTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,SNDBUF),
     &                                                      MIDS2,INFO)
        ENDIF

        SWPBUF=RCVBUF
        RCVBUF=SNDBUF
        SNDBUF=SWPBUF

100   CONTINUE
      NMSG=NMSG+2*NPROC
C**                                                                 ***
C**   the date are available on the buffer SNDBUF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** write nodes (dataset 781):                                    ***
C**   -----------                                                   ***
C**                                                                 ***
      IF (MYTID.EQ.IOTID) THEN
        WRITE(UNIOUT,'(I6)') -1
        WRITE(UNIOUT,'(I6)') 781
	NCARD=NCARD+2
        DO 400 P=1,NPROC
	  IF (TIDS(P).NE.IOTID) THEN
	    CALL MPSNDA(TIDS(P),NMSG+P,IINT,TOKEN,MIDS1,INFO)
	    CALL MPSNDW(TIDS(P),NMSG+P,IINT,TOKEN,MIDS1,INFO)
	    CALL MPRCVA(TIDS(P),NMSG+P+NPROC,IINT*LBFI,
     &                                       IBUF(1,SNDBUF),MIDR1,INFO)
	    CALL MPRCVA(TIDS(P),NMSG+P+2*NPROC,IREAL*LBFR,
     &                                       RBUF(1,SNDBUF),MIDR2,INFO)
	    CALL MPRCVW(TIDS(P),NMSG+P+NPROC,IINT*LBFI,
     &                                       IBUF(1,SNDBUF),MIDR1,INFO)
	    CALL MPRCVW(TIDS(P),NMSG+P+2*NPROC,IREAL*LBFR,
     &                                       RBUF(1,SNDBUF),MIDR2,INFO)
          ENDIF
          NDEGL=IBUF(1,SNDBUF)
          NDEG0L=IBUF(2,SNDBUF)
          DO 300 Z=1,NDEGL
            IF (IBUF(2+Z,SNDBUF).GT.0) THEN
              WRITE(UNIOUT,'(4I10)') Z+NDEG0L,0,0,11
              WRITE(UNIOUT,'(3D25.16)')
     &              (RBUF(DIM*(Z-1)+J,SNDBUF),J=1,DIM),(0.D0,J=DIM+1,3)
	      NCARD=NCARD+2
            ENDIF
 300      CONTINUE
400     CONTINUE
        WRITE(UNIOUT,'(I6)') -1
	NCARD=NCARD+1
      ELSE
        CALL MPRCVA(IOTID,NMSG+MYPROC,IINT,TOKEN,MIDR1,INFO)
        CALL MPRCVW(IOTID,NMSG+MYPROC,IINT,TOKEN,MIDR1,INFO)
        CALL MPSNDA(IOTID,NMSG+MYPROC+NPROC,IINT*LBFI,
     &                                       IBUF(1,SNDBUF),MIDS1,INFO)
        CALL MPSNDA(IOTID,NMSG+MYPROC+2*NPROC,IREAL*LBFR,
     &                                       RBUF(1,SNDBUF),MIDS2,INFO)
        CALL MPSNDW(IOTID,NMSG+MYPROC+NPROC,IINT*LBFI,
     &                                       IBUF(1,SNDBUF),MIDS1,INFO)
        CALL MPSNDW(IOTID,NMSG+MYPROC+2*NPROC,IREAL*LBFR,
     &                                       RBUF(1,SNDBUF),MIDS2,INFO)
      ENDIF
      NMSG=NMSG+3*NPROC
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** End of Calculation :                                          ***
C**   ------------------                                            ***
C**                                                                 ***
      R E T U R N
C-----End of VEID02----------------------------------------------------
      E    N    D
