C:::::      ,,,,,VEIS10...
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**      1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      SUBROUTINE VEIS10 (CLASS,FORM,GEOTYP,ELID,ZW)
     &
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**    VEIS10    resort the vecfem sorting of the local nodes       ***
C**              to the isvas sorting.                              ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**        Copyrights University of Karlsruhe, 1995                 ***
C**        Program by L. Grosz                                      ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
       IMPLICIT NONE
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      Formal Parameters :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      INTEGER           ELID,GEOTYP,ZW(GEOTYP),CLASS,FORM
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   List of Formal Parameters :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C Name   I Type I i/o I Meaning
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C CLASS  I  I   I in  I dimension of the element
C--------I------I-----I------------------------------------------------
C FORM   I  I   I in  I number of vertices
C--------I------I-----I------------------------------------------------
C GEOTYP I  I   I in  I number of nodes
C--------I------I-----I------------------------------------------------
C ELID   I  I   I out I element type
C        I      I     I ELID=0  => no ISVAS element is requested
C--------I------I-----I------------------------------------------------
C ZW     I  I   I i/o I array of nodes of the element
C--------I------I-----I------------------------------------------------
C**                    >                                            ***
      INTEGER           ZW2(32),I
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** Start of Calculation :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
      ELID = 0
      DO 10 I=1,GEOTYP
  10   ZW2(I)=ZW(I)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** BRICK20                                                       ***
C**                                                                 ***
      IF ((CLASS.EQ.3).AND.(FORM.EQ.8).AND.(GEOTYP.EQ.20)) THEN
       ELID=1
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(6)
       ZW(3)=ZW2(5)
       ZW(4)=ZW2(1)
       ZW(5)=ZW2(3)
       ZW(6)=ZW2(7)
       ZW(7)=ZW2(8)
       ZW(8)=ZW2(4)
       ZW(9)=ZW2(14)
       ZW(10)=ZW2(17)
       ZW(11)=ZW2(13)
       ZW(12)=ZW2(9)
       ZW(13)=ZW2(15)
       ZW(14)=ZW2(19)
       ZW(15)=ZW2(16)
       ZW(16)=ZW2(11)
       ZW(17)=ZW2(10)
       ZW(18)=ZW2(18)
       ZW(19)=ZW2(20)
       ZW(20)=ZW2(12)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** BRICK8                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.3).AND.(FORM.EQ.8).AND.(GEOTYP.EQ.8)) THEN
       ELID=2
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(6)
       ZW(3)=ZW2(5)
       ZW(4)=ZW2(1)
       ZW(5)=ZW2(3)
       ZW(6)=ZW2(7)
       ZW(7)=ZW2(8)
       ZW(8)=ZW2(4)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** TETRA10                                                       ***
C**                                                                 ***
      IF ((CLASS.EQ.3).AND.(FORM.EQ.4).AND.(GEOTYP.EQ.10)) THEN
       ELID=3
       ZW(1)=ZW2(3)
       ZW(2)=ZW2(2)
       ZW(3)=ZW2(1)
       ZW(4)=ZW2(4)
       ZW(5)=ZW2(6)
       ZW(6)=ZW2(5)
       ZW(7)=ZW2(7)
       ZW(8)=ZW2(10)
       ZW(9)=ZW2(9)
       ZW(10)=ZW2(8)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** TETRA4                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.3).AND.(FORM.EQ.4).AND.(GEOTYP.EQ.4)) THEN
       ELID=4
       ZW(1)=ZW2(3)
       ZW(2)=ZW2(2)
       ZW(3)=ZW2(1)
       ZW(4)=ZW2(4)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** PLATE8                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.2).AND.(FORM.EQ.4).AND.(GEOTYP.EQ.8)) THEN
       ELID=5
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(3)
       ZW(3)=ZW2(4)
       ZW(4)=ZW2(1)
       ZW(5)=ZW2(6)
       ZW(6)=ZW2(7)
       ZW(7)=ZW2(8)
       ZW(8)=ZW2(5)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** PLATE6                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.2).AND.(FORM.EQ.3).AND.(GEOTYP.EQ.6)) THEN
       ELID=6
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(3)
       ZW(3)=ZW2(1)
       ZW(4)=ZW2(5)
       ZW(5)=ZW2(6)
       ZW(6)=ZW2(4)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** PLATE4                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.2).AND.(FORM.EQ.4).AND.(GEOTYP.EQ.4)) THEN
       ELID=7
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(3)
       ZW(3)=ZW2(4)
       ZW(4)=ZW2(1)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** PLATE3                                                        ***
C**                                                                 ***
      IF ((CLASS.EQ.2).AND.(FORM.EQ.3).AND.(GEOTYP.EQ.3)) THEN
       ELID=8
       ZW(1)=ZW2(2)
       ZW(2)=ZW2(3)
       ZW(3)=ZW2(1)
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** End of Calculation :                                          ***
C**   ------------------                                            ***
C**                                                                 ***
      R E T U R N
C-----End of VEIS10----------------------------------------------------
      E    N    D
