C:::::      ,,,,,VEPA02...
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**      1         2         3         4         5         6         7*
C**********************************************************************
C**                                                                 ***
C**                                                                 ***
      SUBROUTINE VEPA02 (UNIOUT,NODNUM,NOD,DIM,NN,NDEG,TOTNE,
     &                   SBT,LBFI,IBUF,LBFR,RBUF,NDEGL,NDEG0L,
     &                   IOTID,MYPROC,NPROC,TIDS,NMSG,NCARD)
C**                                                                 ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**      VEPA02      write nodes to neutral file                    ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
C**        Copyrights University of Karlsruhe, 1995                 ***
C**        Program by L. Grosz                                      ***
C**                                                                 ***
C**********************************************************************
C**                                                                 ***
       IMPLICIT NONE
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**      Formal Parameters :                                        ***
C**      -----------------                                          ***
C**                                                                 ***
C**                    >                                            ***
      INTEGER           UNIOUT,NN,DIM,NDEG,NDEGL,NDEG0L,TOTNE,
     &                  IOTID,MYPROC,NPROC,NMSG,LBFI,LBFR,NCARD,SBT
      INTEGER           NODNUM(NDEG),IBUF(LBFI,SBT),TIDS(NPROC)
      DOUBLE PRECISION  NOD(NN,DIM),RBUF(LBFR,SBT)
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   List of Formal Parameters :                                   ***
C**   -------------------------                                     ***
C**                                                                 ***
C--------I------I-----I------------------------------------------------
C Name   I Type I i/o I Meaning
C--------I------I-----I------------------------------------------------
C--------I------I-----I------------------------------------------------
C UNIOUT I  I   I in  I unit of output file
C--------I------I-----I------------------------------------------------
C NODNUM I  I   I in  I node id numbers             array: NODNUM(NDEG)
C--------I------I-----I------------------------------------------------
C DIM    I  I   I in  I space dimension
C--------I------I-----I------------------------------------------------
C NOD    I  R   I in  I node coordinates             array: NOD(NN,DIM)
C--------I------I-----I------------------------------------------------
C NDEGL  I  I   I in  I number of geometrical nodes in the
C        I      I     I node buffer on the process
C--------I------I-----I------------------------------------------------
C NDEG0L I  I   I in  I first geometrical node-1 in the
C        I      I     I node buffer on the process
C--------I------I-----I------------------------------------------------
C TOTNE  I  I   I in  I total number of elements will be writen
C--------I------I-----I------------------------------------------------
C SBT    I  I   I in  I =1 no switching buffer technique
C        I      I     I =2 use switching buffer technique
C--------I------I-----I------------------------------------------------
C IBUF   I  I   I -   I integer buffer            array: IBUF(LBFI,SBT)
C--------I------I-----I------------------------------------------------
C RBUF   I  R   I -   I real buffer               array: RBUF(LBFR,SBT)
C--------I------I-----I------------------------------------------------
C MYPROC I  I   I in  I process id
C--------I------I-----I------------------------------------------------
C NPROC  I  I   I in  I number of processes
C--------I------I-----I------------------------------------------------
C TIDS   I  I   I in  I task ids                     array: TIDS(NPROC)
C--------I------I-----I------------------------------------------------
C NMSG   I  I   I i/o I message counter
C--------I------I-----I------------------------------------------------
C NCARD  I  I   I i/o I card counter
C--------I------I-----I------------------------------------------------
C**                    >                                            ***
      INTEGER           J,TOTID,FRTID,LL9MAP,P,MIDS1,MIDR1,NH,INFO,
     &                  Z,MYTID,TOKEN(1),MYDEG,TOTDEG,MIDR2,MIDS2,
     &                  SWPBUF,RCVBUF,SNDBUF,IHELP(1)
      include"bytes.h"
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** Start of Calculation :                                        ***
C**   ---------------------                                         ***
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** distribution of nodes :                                       ***
C**   ---------------------                                         ***
C**                                                                 ***
      MYTID=TIDS(MYPROC)
      TOTID=TIDS(LL9MAP(MYPROC+1,NPROC))
      FRTID=TIDS(LL9MAP(MYPROC-1,NPROC))
      RCVBUF=1
      SNDBUF=RCVBUF+(SBT-1)
	
      IBUF(1,SNDBUF)=NDEGL
      IBUF(2,SNDBUF)=NDEG0L
      DO 100 P=1,NPROC
	IF (P.EQ.1) THEN
	  IF (NPROC.GT.1) THEN
	    CALL MPRCVA(FRTID,NMSG+P,IINT*2,IBUF(1,RCVBUF),MIDR1,INFO)
	    CALL MPSNDA(TOTID,NMSG+P,IINT*2,IBUF(1,SNDBUF),MIDS1,INFO)
          ENDIF
	  DO 101 Z=3,LBFI
101         IBUF(Z,RCVBUF)=0
	  DO 102 Z=1,LBFR
102           RBUF(Z,RCVBUF)=0
	  IF (NPROC.GT.1) THEN
	    CALL MPSNDW(TOTID,NMSG+P,IINT*2,IBUF(1,SNDBUF),MIDS1,INFO)
	    CALL MPRCVW(FRTID,NMSG+P,IINT*2,IBUF(1,RCVBUF),MIDR1,INFO)
          ENDIF
	ELSE
	  CALL MPRCVA(FRTID,NMSG+P,IINT*LBFI,IBUF(1,RCVBUF),MIDR1,INFO)
	  CALL MPRCVA(FRTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,RCVBUF),
     &                                                      MIDR2,INFO)
	  CALL MPSNDA(TOTID,NMSG+P,IINT*LBFI,IBUF(1,SNDBUF),MIDS1,INFO)
	  CALL MPSNDA(TOTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,SNDBUF),
     &                                                      MIDS2,INFO)
	  CALL MPRCVW(FRTID,NMSG+P,IINT*LBFI,IBUF(1,RCVBUF),MIDR1,INFO)
        ENDIF
C**                                                                 ***
        NDEGL=IBUF(1,RCVBUF)
        NDEG0L=IBUF(2,RCVBUF)
	DO 130 Z=1,NDEG
	  NH=NODNUM(Z)-NDEG0L
	  IF ((NH.GT.0).AND.(NH.LE.NDEGL)) IBUF(2+NH,RCVBUF)=1
130     CONTINUE
C**                                                                 ***
	IF (P.GT.1) THEN
	  CALL MPRCVW(FRTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,RCVBUF),
     &                                                      MIDR2,INFO)
        ENDIF
C**                                                                 ***
	DO 131 J=1,DIM
	  DO 131 Z=1,NDEG
	    NH=NODNUM(Z)-NDEG0L
	    IF ((NH.GT.0).AND.(NH.LE.NDEGL)) 
     & 				     RBUF(DIM*(NH-1)+J,RCVBUF)=NOD(Z,J)
131     CONTINUE
C**                                                                 ***
	IF (P.EQ.1) THEN
	  IF (NPROC.GT.1) 
     &       CALL MPSNDW(TOTID,NMSG+P,IINT*2,IBUF(1,SNDBUF),MIDS1,INFO)
	ELSE
	  CALL MPSNDW(TOTID,NMSG+P,IINT*LBFI,IBUF(1,SNDBUF),MIDS1,INFO)
	  CALL MPSNDW(TOTID,NMSG+P+NPROC,IREAL*LBFR,RBUF(1,SNDBUF),
     &                                                      MIDS2,INFO)
        ENDIF
        SWPBUF=RCVBUF
        RCVBUF=SNDBUF
        SNDBUF=SWPBUF
100   CONTINUE
      NMSG=NMSG+NPROC*2
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** count used geometrical nodes :                                ***
C**   -----------------------------                                 ***
C**                                                                 ***
      NDEGL=IBUF(1,SNDBUF)
      MYDEG=0
      DO 330 Z=1,NDEGL
         IF (IBUF(2+Z,SNDBUF).NE.0) MYDEG=MYDEG+1
330   CONTINUE

      TOTDEG=MYDEG
      IF ((MYPROC.EQ.NPROC).AND.(NPROC.GT.1)) THEN
	 IHELP(1)=MYDEG
	 CALL MPSNDA(TIDS(NPROC-1),NMSG+1,IINT,IHELP,MIDS1,INFO)
	 CALL MPSNDW(TIDS(NPROC-1),NMSG+1,IINT,IHELP,MIDS1,INFO)
      ENDIF
      IF ((MYPROC.LT.NPROC).AND.(MYPROC.GT.1)) THEN
	 CALL MPRCVA(TIDS(MYPROC+1),NMSG+1,IINT,IHELP,MIDR1,INFO)
	 CALL MPRCVW(TIDS(MYPROC+1),NMSG+1,IINT,IHELP,MIDR1,INFO)
	 IHELP(1)=IHELP(1)+MYDEG
	 CALL MPSNDA(TIDS(MYPROC-1),NMSG+1,IINT,IHELP,MIDR1,INFO)
	 CALL MPSNDW(TIDS(MYPROC-1),NMSG+1,IINT,IHELP,MIDR1,INFO)
      ENDIF
      IF ((MYPROC.EQ.NPROC).AND.(NPROC.GT.1)) THEN
	 CALL MPRCVA(TIDS(2),NMSG+1,IINT,IHELP,MIDR1,INFO)
	 CALL MPRCVW(TIDS(2),NMSG+1,IINT,IHELP,MIDR1,INFO)
	 TOTDEG=IHELP(1)+MYDEG
      ENDIF
      NMSG=NMSG+1
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   write summary card (packet type 26):                          ***
C**   -----------------------------------                           ***
C**                                                                 ***
      IF (MYTID.EQ.IOTID) THEN
        WRITE(UNIOUT,'(I2,8I8)') 26,0,0,1,TOTDEG,TOTNE,0,0,0
        WRITE(UNIOUT,'(80A)') '00-JAN-00   00:00:00     NIX00'
	NCARD=NCARD+2
      ENDIF
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**   write nodes (packet type 1):                                  ***
C**   ----------------------------                                  ***
C**                                                                 ***
      IF (MYTID.EQ.IOTID) THEN
        DO 400 P=1,NPROC
	  IF (TIDS(P).NE.IOTID) THEN
	    CALL MPSNDA(TIDS(P),NMSG+P,IINT,TOKEN,MIDS1,INFO)
	    CALL MPSNDW(TIDS(P),NMSG+P,IINT,TOKEN,MIDS1,INFO)
	    CALL MPRCVA(TIDS(P),NMSG+P+NPROC,IINT*LBFI,IBUF(1,SNDBUF),
     &                                                    MIDR1,INFO)
	    CALL MPRCVA(TIDS(P),NMSG+P+2*NPROC,IREAL*LBFR,
     &                                      RBUF(1,SNDBUF),MIDR2,INFO)
	    CALL MPRCVW(TIDS(P),NMSG+P+NPROC,IINT*LBFI,IBUF(1,SNDBUF),
     &                                                    MIDR1,INFO)
	    CALL MPRCVW(TIDS(P),NMSG+P+2*NPROC,IREAL*LBFR,
     &                                      RBUF(1,SNDBUF),MIDR2,INFO)
          ENDIF
          NDEGL=IBUF(1,SNDBUF)
          NDEG0L=IBUF(2,SNDBUF)
          DO 300 Z=1,NDEGL
            IF (IBUF(2+Z,SNDBUF).GT.0) THEN
              WRITE(UNIOUT,'(I2,8I8)') 1,Z+NDEG0L,0,2,(0,J=1,5)
              WRITE(UNIOUT,'(3E16.9)')
     &              (RBUF(DIM*(Z-1)+J,SNDBUF),J=1,DIM),(0.D0,J=DIM+1,3)
              WRITE(UNIOUT,'(I1,A1,3I8,A2,6I1)')
     &                                1,'G',6,0,0,'  ',(0,J=1,6)
	      NCARD=NCARD+3
            ENDIF
 300      CONTINUE
400     CONTINUE
      ELSE
	CALL MPRCVA(IOTID,NMSG+MYPROC,IINT,TOKEN,MIDR1,INFO)
	CALL MPRCVW(IOTID,NMSG+MYPROC,IINT,TOKEN,MIDR1,INFO)
        CALL MPSNDA(IOTID,NMSG+MYPROC+NPROC,IINT*LBFI,IBUF(1,SNDBUF),
     &                                                    MIDS1,INFO)
        CALL MPSNDA(IOTID,NMSG+MYPROC+2*NPROC,IREAL*LBFR,
     &                                     RBUF(1,SNDBUF),MIDS2,INFO)
        CALL MPSNDW(IOTID,NMSG+MYPROC+NPROC,IINT*LBFI,IBUF(1,SNDBUF),
     &                                                    MIDS1,INFO)
        CALL MPSNDW(IOTID,NMSG+MYPROC+2*NPROC,IREAL*LBFR,
     &                                     RBUF(1,SNDBUF),MIDS2,INFO)
      ENDIF
      NMSG=NMSG+3*NPROC
C**                                                                 ***
C**-----------------------------------------------------------------***
C**                                                                 ***
C**** End of Calculation :                                          ***
C**   ------------------                                            ***
C**                                                                 ***
      R E T U R N
C-----End of VEPA02----------------------------------------------------
      E    N    D
